# CCS'24 submission

This directory contains HTML files allowing to visualise, on our set of
case studies, the Squirrel proofs step by step without having to install
Squirrel and its Proof General mode.

Case studies include proofs of protocols with cryptographic hypotheses
supported by legacy tactics:

- `basic-hash.html`: unlinkability of the protocol Basic-Hash
  using the EUF-MAC and PRF hypotheses;
- `global-cpa.html`: protocol-level handling of indistinguishabilities
  using the IND-CPA game;
- `hash-lock.html`: strong secrecy in the Hash-Lock protocol
  using the PRF axiom.

We also include two proofs using new cryptographic hypotheses
(not previously supported by Squirrel):

- `private-authentication.html`: anonymity in the Private Authentication
  protocol under the CCA$ hypothesis;
- `nsl.html`: equivalence of NSL protocol with its idealization using
  IND-CCA2 (main step in proving strong secrecy of nonces).

Details can be found in the files themselves.

# Warning

Make sure to extract the full directory before opening the files.
