(**************************************************************************)
(*                                                                        *)
(*  Copyright (C) Jean-Christophe Filliatre                               *)
(*                                                                        *)
(*  This software is free software; you can redistribute it and/or        *)
(*  modify it under the terms of the GNU Library General Public           *)
(*  License version 2.1, with the special exception on linking            *)
(*  described in file LICENSE.puf                                         *)
(*                                                                        *)
(*  This software is distributed in the hope that it will be useful,      *)
(*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                  *)
(*                                                                        *)
(**************************************************************************)

(** A persistent union-find data structure.

   The datatype [t] maintains a partition of the set [0,1,...,n-1],
   where [n] is the value passed to [create]. *)

type t

val create : int -> t

val find : t -> int -> int

(* if [ignore_rank] is true, the left element is always choosen as 
   representent of the union. *)
val union : ?ignore_rank:bool -> t -> int -> int -> t
